![Ackee Froentend Toolkit](https://cdn6.aptoide.com/imgs/f/2/e/f2e4802678264d40830b66f0459f7527_icon.png?w=256)

# Ackee Frontend Tookit
> Set of tools, libraries and all stuff useful for frontend development in Ackee having DRY in mind.

## How to use

1. Install
It's not published yet so now the best way to install it is using
`yarn add ackee-frontend-toolkit`
or
`npm install ackee-frontend-toolkit`.
2. Import
Depending on your prefered module managment system, you can use directory `ackee-frontend-toolkit/lib` (CommonJS) or `ackee-frontend-toolkit/es` (ES2015) to import things you need.


You can choose one of three ways for importing:
```js
// 1. Import partially
import loadable from 'ackee-frontend-toolkit/HOC/loadable';

loadable(...)

// 2. Import from namespace
import * HOC from 'ackee-frontend-toolkit/HOC';

HOC.loadable(...)

// 3. Import from full package
import * ackee from 'ackee-frontend-toolkit';

ackee.loadable(...)
 ```

## How to develop

`yarn build` or `npm run build` make sources prepared to use.

## What's inside

### Components

* [DataList](/docs/components/dataList.md)

### High order components
 * [loadable](/docs/HOC/loadable.md)
 * [makeDropzone](/docs/HOC/makeDropzone.md)
 * [translatable](/docs/HOC/translatable.md)
 * authorizable
 * [errorBoundary](/docs/HOC/errorBoundary.md)
 * [pure](/docs/HOC/pure.md)

### Helpers
 * [auth helpers](/docs/helpers/auth.md)
 * [action types helper](/docs/helpers/actionTypes.md)
 * testing helpers

### Sagas
 * [routing](/docs/sagas/routing.md)
 * [formSubmit](/docs/sagas/formSubmit.md)

### Actions
* [form](/docs/actions/formActions.md)
* [logging](/docs/actions/loggingActions.md)

### [Selectors](/docs/selectors/index.md)

## What we use

We don't want to invent a wheel every day so we are trying to use as much vendor components, utilities and helpers as possible. We remarked [the approved ones](/docs/vendors.md) to don't let us forget them :)

## Development recipes

* [Using form saga](/docs/recipes/usingFormSaga.md)
* [Lazy loading](/docs/recipes/lazyLoading.md)
