# `createType(prefix, suffixes): `

Utility to help creating Redux action types for API request actions.

### Arguments
1. `prefix` (string): Action type base
2. `suffixes` (Array.<string> [optional]) Array of suffixes to use to make types. Default is `['_COMPLETED', '_SUCCEEDED', '_FAILED']`

### Returns
Object containing redux actions types prepared for HTTP request-response cycle

#### Examples

```js
import createTypes from 'ackee-frontend-toolkit/lib/helpers/actionTypes';

createTypes('REQUEST_FEED');
/* 
 * [
 *    'REQUEST_FEED',
 *    'REQUEST_FEED_SUCCEEDED',
 *    'REQUEST_FEED_FAILED',
 *    'REQUEST_FEED_COMPLETED',
 * ]
 * /
```
