'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reactIntl = require('react-intl');

var _helpers = require('../helpers');

var _selectors = require('../selectors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var translatable = function translatable(messages) {
    return function (TranslatableComponent) {
        var Component = function Component(props) {
            return _react2.default.createElement(
                _reactIntl.IntlProvider,
                {
                    locale: props.locale,
                    messages: messages[props.locale]
                },
                _react2.default.createElement(TranslatableComponent, props)
            );
        };

        Component.displayName = 'Translatable(' + (0, _helpers.getDisplayName)(TranslatableComponent) + ')';
        Component.propTypes = {
            locale: _propTypes2.default.string.isRequired
        };

        return (0, _reactRedux.connect)(function (state) {
            return (0, _selectors.translateSelector)(state);
        })(Component);
    };
};

exports.default = translatable;