'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.changeDisplayType = undefined;
exports.createMessage = createMessage;
exports.uploadImage = uploadImage;
exports.searchConversations = searchConversations;
exports.setSeenMessages = setSeenMessages;
exports.toggleUserOnline = toggleUserOnline;

var _chatActionTypes = require('./chatActionTypes');

var types = _interopRequireWildcard(_chatActionTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function createMessage() {
    return {
        type: types.chat.CREATE_TEXT_MESSAGE
    };
}

function uploadImage(conversationId, image) {
    return {
        type: types.chat.CREATE_IMAGE_MESSAGE,
        conversationId: conversationId,
        image: image
    };
}

function searchConversations() {
    return {
        type: types.chat.SEARCH_CONVERSATIONS
    };
}

function setSeenMessages(conversationId) {
    return {
        type: types.chat.SET_SEEN_MESSAGES,
        conversationId: conversationId
    };
}

function toggleUserOnline(online) {
    return {
        type: types.chat.TOGGLE_USER_ONLINE,
        online: online
    };
}

var changeDisplayType = exports.changeDisplayType = function changeDisplayType(displayType) {
    return {
        type: types.chat.CHANGE_DISPLAY_TYPE,
        displayType: displayType
    };
};