'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.conversationsListSelector = exports.conversationsSearchValueSelector = exports.conversationsSelector = exports.userConversationsSelector = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dependencies = require('./dependencies');

var _chatConstants = require('./chatConstants');

var _chatConstants2 = _interopRequireDefault(_chatConstants);

var _paths = require('./firebase/paths');

var paths = _interopRequireWildcard(_paths);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var userIdFromPropsSelector = function userIdFromPropsSelector(state, props) {
    return props.userId;
};
/*
// eslint-disable-next-line
export const unseenSelector = createSelector([
    authUser,
    firebaseSelector,
], (user, firebase) => (id) => {
    const conversation = _.get(
        firebase,
        `data.${config.firebase.conversation(id).store}`,
        {}
    );
    const users = _.get(conversation, 'users');
    const userId = getUserFirebaseId(user);
    const unseen = {};
    if (!isEmpty(users)) {
        Object.keys(users).forEach(key => {
            if (key !== userId) {
                unseen[key] = true;
            }
        });
    }
    return unseen;
});

export const firebaseUserSelector = createSelector([
    firebaseSelector,
    simplifiedDriversSelector,
], (firebase, { drivers }) => (id) => {
    let tripId = null;
    if (typeof id === 'string') {
        const [userPrefix, userId] = id.split('_');
        if (userPrefix === chatConstants.Prefixes.DRIVER) {
            const driver = drivers.find(item => item.id === Number(userId));
            if (driver) {
                tripId = _.get(driver, 'activeTrip.id');
            }
        }
    }
    const user = _.get(
        firebase,
        `data.${config.firebase.user(id).store}`,
        {}
    );
    return ({
        isEmpty: isEmpty(user),
        isLoaded: isLoaded(user),
        user: {
            ...user,
            tripId,
        },
    });
});

export const messagesSelector = createSelector([
    firebaseSelector,
], (firebase) => (id) => {
    const messages = (_.get(
        firebase,
        `ordered.${config.firebase.conversationMessages(id).store}`,
        []
    ) || []).map(item => ({
        ...item.value,
        key: item.key,
    }));
    return ({
        isEmpty: isEmpty(messages),
        isLoaded: isLoaded(messages),
        messages,
    });
});*/

/**
 * Selects last message of every conversation
 * With active trip of driver that the conversation is about
 */
/* export const fullLastMessagesSelector = createSelector([
    authUser,
    firebaseSelector,
    simplifiedDriversSelector,
], (user, firebase, { drivers }) => {
    const userId = getUserFirebaseId(user);

    const userConversations = populate(
        firebase,
        config.firebase.userConversations(userId).store,
        config.firebase.populates.conversations,
    );

    return _.filter(userConversations, userConversation => _.has(userConversation, 'conversation.lastMessage'))
        .map(userConversation => ({
            conversationId: _.get(userConversation, 'conversation.id'),
            ..._.get(userConversation, 'conversation.lastMessage'),
        }))
        .map(message => {
            const [userPrefix, id] = message.conversationId.split('_');
            if (userPrefix === chatConstants.Prefixes.DRIVER) {
                const driver = drivers.find(item => item.id === Number(id));
                if (driver) {
                    message.tripId = _.get(driver, 'activeTrip.id');
                }
            }
            return message;
        })
        .sort((a, b) => (a.time < b.time));
});*/

var userConversationsSelector = exports.userConversationsSelector = (0, _dependencies.createSelector)(userIdFromPropsSelector, _dependencies.firebaseSelector, function (userId, firebase) {
    var userConversations = (0, _dependencies.populate)(firebase, paths.userConversations(userId).store, paths.populates.conversations);

    var activeUserConversations = (0, _dependencies._filter)(userConversations, function (userConversation) {
        return (0, _dependencies._has)(userConversation, 'conversation');
    }).map(function (userConversation) {
        var conversation = userConversation.conversation;


        return _extends({
            conversationId: (0, _dependencies._isString)(conversation) ? conversation : conversation.id
        }, userConversation);
    });

    return activeUserConversations;
});

var hasUnseenMessages = function hasUnseenMessages(conversation) {
    return Boolean(conversation.unseenMessagesCount > 0);
};
var isUnseenMoreRecent = function isUnseenMoreRecent(conversation) {
    return (0, _dependencies._get)(conversation, ['lastMessage', 'time'], 0);
};

var conversationsSelector = exports.conversationsSelector = (0, _dependencies.createSelector)(userConversationsSelector, function (userConversations) {
    var conversations = userConversations.map(function (_ref) {
        var conversationId = _ref.conversationId,
            unseenMessagesCount = _ref.unseenMessagesCount,
            conversation = _ref.conversation;
        return {
            conversationId: conversationId,
            lastMessage: (0, _dependencies._get)(conversation, 'lastMessage'),
            unseenMessagesCount: unseenMessagesCount
        };
    });

    conversations = (0, _dependencies._orderBy)(conversations, [hasUnseenMessages, isUnseenMoreRecent], ['desc', 'desc']);

    return {
        isEmpty: conversations.legth === 0,
        isLoaded: true, // TODO,
        conversations: conversations
    };
});

var conversationsSearchFormSelector = (0, _dependencies.formValueSelector)(_chatConstants2.default.SEARCH_CONVERSATION_FORM_ID);

var conversationsSearchValueSelector = exports.conversationsSearchValueSelector = function conversationsSearchValueSelector(state) {
    return conversationsSearchFormSelector(state, 'text');
};

var firebaseUsersSelector = (0, _dependencies.createSelector)(_dependencies.firebaseSelector, function (firebase) {
    return (0, _dependencies._get)(firebase, 'data.' + paths.users().store, {});
});

var isConversationMatchedByFilter = function isConversationMatchedByFilter(_ref2, filterValue) {
    var user = _ref2.user;

    var userName = (0, _dependencies._get)(user, 'name');
    return (0, _dependencies._isString)(userName) && userName.toLowerCase().includes(filterValue.toLowerCase());
};

var conversationsListSelector = exports.conversationsListSelector = (0, _dependencies.createSelector)(conversationsSelector, firebaseUsersSelector, _dependencies.firebaseSelector, conversationsSearchValueSelector, function (_ref3, users, firebase, searchFormValue) {
    var conversations = _ref3.conversations;

    var conversationsList = conversations.map(function (conversation) {
        var conversationId = conversation.conversationId;

        var conversationDetail = (0, _dependencies._get)(firebase, 'data.' + paths.conversation(conversationId).store, {});

        var user = users[conversationId];
        var authorId = (0, _dependencies._get)(conversation, 'lastMessage.author');
        var author = users[authorId];

        return {
            conversation: _extends({}, conversation, conversationDetail),
            user: _extends({}, user, {
                id: conversationId
            }),
            author: _extends({}, author, {
                id: authorId
            })
        };
    });

    if (searchFormValue) {
        return conversationsList.filter(function (conversation) {
            return isConversationMatchedByFilter(conversation, searchFormValue);
        });
    }

    return conversationsList;
});

/* export const conversationSelector = createSelector(
    conversationsListSelector,
    (conversations) => (id) => {
        const conversation = _.get(
            conversations.find(c => c.conversation.id === id),
            'conversation',
            {}
        );

        return ({
            isEmpty: false,
            isLoaded: Boolean(conversation.id),
            conversation: {
                ...conversation,
                id,
            },
        });
    }
);

export const unseenConversationsSelector = createSelector(
    userConversationsSelector,
    userConversations => {
        return userConversations.filter(userConversation => {
            return _.get(userConversation, 'unseenMessagesCount', 0) > 0;
        });
    }
);

export const unseenConversationsCountsSelector = createSelector(
    unseenConversationsSelector,
    unseenUserConversations => {
        const initialUnseenCounts = {
            [chatConstants.Prefixes.DRIVER]: 0,
            [chatConstants.Prefixes.KAM]: 0,
        };

        return unseenUserConversations.reduce((unseenCounts, userConversation) => {
            unseenCounts[getUserPrefix(userConversation.conversationId)] += 1;
            return unseenCounts;
        }, initialUnseenCounts);
    }
);

export const chatPagingSelector = state => state.app.chat;

export const chatDisplayTypeSelector = createSelector(
    chatTypeSelector,
    type => {
        if (type === chatConstants.Prefixes.DRIVER) {
            return chatConstants.DISPLAY_DRIVERS;
        }
        return chatConstants.DISPLAY_KAM;
    }
);*/